exit_polling/poller_phx/lib/poller_phx_web/router.ex
defmodule PollerPhxWeb.Router do
  alias PollerPhxWeb.ChoiceController
  use PollerPhxWeb, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
    plug PollerPhxWeb.Plugs.Auth
  end

  pipeline :api do
    plug :accepts, ["json"]
    plug :fetch_session
    plug PollerPhxWeb.Plugs.Auth
  end

  scope "/", PollerPhxWeb do
    pipe_through :browser

    get "/", PageController, :index
  end

  scope "/auth", PollerPhxWeb do
    pipe_through :browser

    get "/login", AuthController, :new
    post "/login", AuthController, :create
    delete "/logout", AuthController, :delete
  end

  scope "/districts", PollerPhxWeb do
    pipe_through [:browser, :valid_user, :admin_user]

    # get "/", DistrictController, :index
    # get "/new", DistrictController, :new
    # post "/", DistrictController, :create
    # get "/:id/edit", DistrictController, :edit
    # put "/:id", DistrictController, :update
    # delete "/:id", DistrictController, :delete

    # The below replaces the above
    resources "/", DistrictController, except: [:show]

    # Questions
    resources "/:district_id/questions", QuestionController, except: [:show]

    # Choices
    resources "/:district_id/questions/:question_id/choices", ChoiceController, except: [:show]
  end


  # Other scopes may use custom stacks.
  scope "/api", PollerPhxWeb.Api do
    pipe_through :api

    get "/districts", DistrictController, :index
    get "/districts/:district_id", DistrictController, :show
    get "/districts/:district_id/questions", QuestionController, :index
    get "/questions/:question_id/choices", ChoiceController, :index
  end

  scope "/api", PollerPhxWeb.Api do
    pipe_through [:api, :valid_user]

    get "/districts/:district_id/choices/:choice_id", ChoiceController, :vote
  end

  scope "/app", PollerPhxWeb do
    pipe_through :browser

    get "/*path", AppController, :index
  end
end

exit_polling/poller_phx/lib/poller_phx_web/controllers/api/district_controller.ex
defmodule PollerPhxWeb.Api.DistrictController do
  use PollerPhxWeb, :controller

  alias PollerDal.Districts

  def index(conn, _params) do
    districts = Districts.list_districts()
    render(conn, "index.json", districts: districts)
  end

  def show(conn, %{"district_id" => district_id}) do
    district = Districts.get_district!(district_id)
    render(conn, "show.json", district: district)
  end
end

exit_polling/poller_phx/lib/poller_phx_web/controllers/district_controller.ex
defmodule PollerPhxWeb.DistrictController do
  use PollerPhxWeb, :controller

  alias PollerDal.Districts
  alias PollerDal.Districts.District

  def index(conn, _params) do
    districts = Districts.list_districts()
    render(conn, "index.html", districts: districts)
  end

  def new(conn, _params) do
    changeset = Districts.change_district(%District{})
    render(conn, "new.html", changeset: changeset)
  end

  def create(conn, %{"district" => district_params}) do
    case Districts.create_district(district_params) do
      {:ok, _district} ->
        conn
        |> put_flash(:info, "District created successfully")
        |> redirect(to: Routes.district_path(conn, :index))
      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "new.html", changeset: changeset)
    end
  end

  def edit(conn, %{"id" => id}) do
    district = Districts.get_district!(id)
    changeset = Districts.change_district(district)
    render(conn, "edit.html", district: district, changeset: changeset)
  end

  def delete(conn, %{"id" => id}) do
    district = Districts.get_district!(id)
    {:ok, _district} = Districts.delete_district(district)

    conn
      |> put_flash(:info, "District deleted successfully")
      |> redirect(to: Routes.district_path(conn, :index))
  end

  def update(conn, %{"id" => id, "district" => district_params}) do
    district = Districts.get_district!(id)
    case Districts.update_district(district, district_params) do
      {:ok, _district} ->
        conn
        |> put_flash(:info, "District updated successfully")
        |> redirect(to: Routes.district_path(conn, :index))
      {:error, %Ecto.Changeset{} = changeset} ->
        render(conn, "edit.html", district: district, changeset: changeset)
    end
  end
end

exit_polling/poller_phx/lib/poller_phx_web/views/district_view.ex
defmodule PollerPhxWeb.DistrictView do
  use PollerPhxWeb, :view
end

exit_polling/poller_phx/lib/poller_phx_web/templates/district/edit.html.eex
<h1>Edit District</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.district_path(@conn, :update, @district)) %>

exit_polling/poller_phx/lib/poller_phx_web/templates/district/form.html.eex
<%= form_for @changeset, @action, fn f -> %>

  <%= if @changeset.action do %>
    <div class="error">
      <p>Oops, something went wrong! Please check the errors below.</p>
    </div>
  <% end %>

  <%= label f, :name %>
  <%= text_input f, :name %>
  <%= error_tag f, :name %>

  <div>
    <%= submit "Save", class: "btn"  %>
    <%= link "Cancel", to: Routes.district_path(@conn, :index), class: "btn-white"  %>
  </div>
<% end %>

exit_polling/poller_phx/lib/poller_phx_web/templates/district/index.html.eex
<h1>Districts</h1>

<table>
  <thead>
    <tr>
      <th colspan="2">Name</th>
    </tr>
  </thead>
  <tbody>
    <%= for district <- @districts do %>
      <tr>
        <td><%= district.name %></td>
        <td>
          <%= link to: Routes.question_path(@conn, :index, district.id) do
          %>
            <i class="fa fa-question"> </i>
          <% end %>
          <%= link to: Routes.district_path(@conn, :edit, district.id) do
          %>
            <i class="far fa-edit"> </i>
          <% end %>
          <%= link to: Routes.district_path(@conn, :delete, district.id),
            method: :delete,
            data: [confirm: "Are you sure?"]
            do
          %>
            <i class="fas fa-trash"> </i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

<div>
 <%= link "New District", to: Routes.district_path(@conn, :new), class: "btn" %>
</div>

exit_polling/poller_phx/lib/poller_phx_web/templates/district/new.html.eex
<h1>New District</h1>

<%= render "form.html", Map.put(assigns, :action, Routes.district_path(@conn, :create)) %>